﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="ClosureEventHandlers_LeakFree.aspx.cs" Inherits="EventHandlers" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head runat="server">
		<title>Closure Event Handlers - Leak-free</title>
		<script type="text/javascript">
			var buttonHandler;
			function pageLoad()
			{
				buttonHandler = function()
				{
					causeLeak()
				};
				$addHandler($get("button1"), "click", buttonHandler);
			}
			function causeLeak()
			{
				var container = $get("buttonContainer");
				//preventing the leak of the button element
				$removeHandler($get("button1"), "click", buttonHandler);
				container.innerHTML = "";
			}
		</script>
	</head>
	<body>
		<form id="form1" runat="server">
			<asp:ScriptManager ID="theScriptManager" runat="server" />
			<div id="buttonContainer">
				<button id="button1">Leak</button>
			</div>
		</form>
	</body>
</html>
