﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="DynamicDOM_CircularReference.aspx.cs" Inherits="EventHandlers" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head runat="server">
		<title>Dynamically created DOM elements and JavaScript objects</title>
		<script type="text/javascript">
var objContainer = [];
function pageLoad()
{
	$addHandler($get("leaker"), "click", causeLeak);
	$addHandler($get("cleanUp"), "click", function()
	{
		while(objContainer.length)
			objContainer.pop().dispose();
	});
}
function causeLeak()
{
	var container = $get("buttonContainer");
		container.innerHTML = "";
		createButton(container);
}

function createButton(container)
{
	var button = document.createElement("button");
	button.innerHTML = "Simple button";
	container.appendChild(button);
	objContainer.push(new LeakClass(button));
}

function LeakClass(button)
{
	this.button = button;
	this.buttonHandler = Function.createDelegate(this, this.handleButtonClick);
	$addHandler(this.button, "click", this.buttonHandler);
}
LeakClass.prototype =
{
	handleButtonClick: function()
	{
		this.button.isClicked = this.button;
	},
	dispose: function()
	{
		$removeHandler(this.button, "click", this.buttonHandler);
		this.button.isClicked = null;
		delete this.button;
		delete this.buttonHandler;
	}
}
		</script>
	</head>
	<body>
<form id="form1" runat="server">
	<asp:ScriptManager ID="theScriptManager" runat="server" />
	<div id="buttonContainer"></div>
	<button id="leaker">Leak!</button>
	<button id="cleanUp">Clean Up</button>
</form>
	</body>
</html>
